( function( $ ) {

	document.addEventListener('wpcf7mailsent', function( event ) {
		setTimeout(function() {
			var contactform_id = event.detail.contactFormId;
			var redirection_url = event.detail.apiResponse.redirection_url;
			if ( redirection_url != '' && redirection_url != undefined ) {
				window.location = redirection_url;
			}
		}, 4000);

	} );

	jQuery( document ).ready( function($) {
		// turn off multiple submission 
		jQuery( '.wpcf7 form.wpcf7-form.cf7sa' ).off( 'submit' );

		// open card details on pop-up
		$(document).on('click', '.cf7sa_view_card_details' , function () {
			$('.cf7sa_sub_list_wrapper').addClass('cf7sa-in-progress-container');
			cf7sa_clear_the_card_popup();
			let p_id = $(this).data('tid');
			$.ajax({
				type: "POST",
				url: cf7sa_object.ajax_url,
				data: {
					p_id: p_id,
					action: 'cf7sa_action_fetch_subs_card_details'
				},
				success: function (response) {
					if( 'success' === response.status ){
						cf7sa_open_the_card_popup( response );	
					}else{
						alert( response.message );
					}
				},
				complete: function (response) {  
					$('.cf7sa_sub_list_wrapper').removeClass('cf7sa-in-progress-container');
				}
			});
		});

		// update card details of the selected subscription
		$(document).on('click', '.cf7sa-subs-update-card button' , function () {
			let p_id = $(this).data('tid');
			if( 1 <= $('.cf7sa-subs-card-making-wrapper').length  ){
				cf7sa_createPaymentMethodAndSubmit( p_id );
			}else{
				alert('Error: can not find card element');
			}
		});

		// close the popup

		$(document).on('click','.cf7sa-popup-close-btn', function () {
			cf7sa_clear_the_card_popup();
		});

		async function cf7sa_createPaymentMethodAndSubmit( p_id ) {
			const { paymentMethod, error } = await stripe.createPaymentMethod({
				type: 'card',
				card: cardElement,
			});

			console.log( paymentMethod );
			
			if (error) {
				alert('Error: ' + error.message);
			} else {
				// Perform an AJAX request to send the paymentMethod ID to the server
				jQuery.ajax({
					url: cf7sa_object.ajax_url,
					method: 'POST',
					data: {
						action: 'cf7sa_action_update_subs_card_details',
						p_id: p_id,
						paymentMethodId: paymentMethod.id,
					},
					success: function (response) {
						if (response.status == 'success') {
							let notice_ele = $('.cf7sa_card_notice');
							notice_ele.css('color','green');
							notice_ele.html( response.message );
							notice_ele.fadeOut( 1500, function(){
								cf7sa_clear_the_card_popup();
								notice_ele.html( '' );
								notice_ele.removeAttr('style');
							});
						} else {
							console.log( response );
							alert('Error: ' + response.message);
						}
					},
					error: function () {
						alert('An error occurred while updating the card.');
					}
				});
			}
		}

		// opens card details of the current subscription
		function cf7sa_open_the_card_popup( response ){
			$('body').addClass('cf7popup-card-open');
			$('#cf7sa_card_number_wrapper').html( response.stripeCardMountScript );
			$('#last4_cf7sa_hidden_chars').text( response.card_details.last4 );
			$('#cf7sa_popup_wrapper').show();
		}

		function cf7sa_clear_the_card_popup(){
			$('body').removeClass('cf7popup-card-open');
			$('#cf7sa_card_number_wrapper').html('');
			$('#last4_cf7sa_hidden_chars').text('');
			$('#cf7sa_popup_wrapper').hide();
		}
	});



	// document.addEventListener( 'wpcf7submit', function( event ) {
	// 	jQuery('.wpcf7-submit').on('click',function(){
    // 		jQuery(this).prop("disabled",true); // disable button after clicking on button
	// 	});
	// }, false );

} )( jQuery );
